#Sample Signal Handling Program
#Compiled on HP-UX B.10.20.A 9000

#include <stdio.h>
#include <signal.h>

void Message();

main() {

  int pid;
  int i;

  pid = fork();
  if (pid == -1) {
    printf("Could not fork!\n");
    exit(1);
  }

  /* Point - A */
  signal(SIGUSR1, Message);
  /* Signal handler called here */

  if (pid != 0) {
    /* Point - B */
    printf("Parent waiting...\n");
    sleep(5);
    kill(pid, SIGUSR1);
    /* sends kill signal to child process */
  } else {
    /* Point - C */
    while (1) {
      i++;
      if(i%10000==0)
      printf("%d\n", i);
      /* child publishes ever increasing number until killed by parent */
    }
  }

}


void Message()
/* This function is executed once kill signal is sent */
{
   fprintf(stderr, "Time to stop.\n");
   exit(0);
}
